const Modal = (function() {
  const overlay = $('<div id="__modal-overlay"></div>').hide();
  const modal = $('<div id="__modal"></div>').hide();
  const title = $('<div class="title"></div>')
  const content = $('<div class="content"></div>');
  const buttons = $('<div class="buttons"></div>');

  $(document).ready(function() {
    $("body").append(overlay.append(modal.append(title, content, buttons)));
  });

  const self = {};
  self.open = function(caption, message, choices, callback) {
    const chosen = function(result) {
      return function() {
        if (callback) {
          callback(result);
        }
        self.close();
      };
    };
    $(document).on("keyup.modal", function(e) {
      if (e.keyCode === 27) {
        self.close();
      }
    });
    title.empty().append($('<span>').text(caption));
    content.empty().append(message);
    buttons.empty().append(
      choices.map(function(choice) {
        const button = $(
          '<input type="submit" value="' + choice.value + '" class="button ' + (choice.classname === null ? '' : choice.classname) + '"/>'
        );
        button.click(chosen(choice.value));
        return button;
      })
    );
    buttons.find(".button:not(:first-child)").addClass("button--secondary");
    overlay.fadeIn();
    modal.fadeIn();
    buttons.find(".button:first-child").focus();
  };

  self.close = function() {
    $(document).unbind("keyup.modal");
    $(overlay).unbind("click.modal");
    $(modal).unbind("click.modal");
    modal.fadeOut(function() {
      modal.removeClass();
      modal.removeAttr("style");
    });
    overlay.fadeOut();
  };
  return self;
})();
